From 10c48f5904077748f3531a8c7062862cda5e0b49 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Jan 03 2021 00:40:08 +0000
Subject: [PATCH 1994/2232] Resolve msvc warning on strncpy by replacing with memcpy


    src/cxx.cc(356): error C2220: the following warning is treated as an error
    src/cxx.cc(356): warning C4996: 'strncpy': This function or variable may be unsafe. Consider using strncpy_s instead. To disable deprecation, use _CRT_SECURE_NO_WARNINGS. See online help for details.

---

diff --git a/src/cxx.cc b/src/cxx.cc
index 15dc998..56c3696 100644
--- a/src/cxx.cc
+++ b/src/cxx.cc
@@ -355,9 +355,8 @@ static_assert(!std::is_same<Vec<std::uint8_t>::const_iterator,
 
 extern "C" {
 const char *cxxbridge1$error(const char *ptr, std::size_t len) noexcept {
-  char *copy = new char[len];
-  std::strncpy(copy, ptr, len);
-  return copy;
+  return ptr ? static_cast<char *>(std::memcpy(new char[len], ptr, len))
+             : nullptr;
 }
 } // extern "C"
 

